create or replace 
PROCEDURE CRIACARD_CICLO(
   P_CDFILIAL   IN CARDADIA.CDFILIAL%TYPE,
   P_CDSERVFILI IN CARDADIA.CDSERVFILI%TYPE,
   P_DTMESCARD  IN CARDADIA.DTMESCARD%TYPE,
   P_CDOPERADOR IN CARDADIA.CDOPERADOR%TYPE,
   P_IDEXCLUIRCARD IN VARCHAR2,
   P_NRLOGCARDCICLO IN LOGCARDCICLO.NRLOGCARDCICLO%TYPE,
   P_CDPADCICLO IN PADRAOCICLO.CDPADCICLO%TYPE) 
   
IS

   V_NRCARDAPIO VARCHAR2(20);
   V_NRCARDAGRE VARCHAR2(20);
   V_CARDESPEC  VARCHAR2(1);
   V_CDGRUPOPER VARCHAR2(02);
   V_DTMESCARDAPIO DATE;
   V_CDOPERADOR VARCHAR2(12);
   V_IDUTRPADCA VARCHAR2(01);
   V_CONTPRODRECE NUMBER;
   V_TIPORECE VARCHAR2(01);
   V_CDNVPRODUTO VARCHAR2(01);
   V_PRODINATIVO BOOLEAN;
   V_CDCARD VARCHAR2(10);
   V_COUNT NUMBER;
   V_DTLIBECARDMATR DATE;
   V_IDCARDDESCENTR VARCHAR2(1);
   V_NRSEQLOG NUMBER;
   V_CDCARDCICLO VARCHAR2(05);
   V_NRCICLO VARCHAR2(3);
   V_MAXDATA DATE;
   V_VRPECONSCARD FLOAT(126);
   V_CDPRATO VARCHAR2(10);

   /* VARIAVEIS - TABELA DE SERVICO */
   V_QTCOMESTISEG NUMBER;
   V_QTCOMESTITER NUMBER;
   V_QTCOMESTIQUA NUMBER;
   V_QTCOMESTIQUI NUMBER;
   V_QTCOMESTISEX NUMBER;
   V_QTCOMESTISAB NUMBER;
   V_QTCOMESTIDOM NUMBER;
   V_QTCOMESTIFER NUMBER;
   V_QTCLIESTISEG NUMBER;
   V_QTCLIESTITER NUMBER;
   V_QTCLIESTIQUA NUMBER;
   V_QTCLIESTIQUI NUMBER;
   V_QTCLIESTISEX NUMBER;
   V_QTCLIESTISAB NUMBER;
   V_QTCLIESTIDOM NUMBER;
   V_QTCLIESTIFER NUMBER;
   V_QTFUNESTISEG NUMBER;
   V_QTFUNESTITER NUMBER;
   V_QTFUNESTIQUA NUMBER;
   V_QTFUNESTIQUI NUMBER;
   V_QTFUNESTISEX NUMBER;
   V_QTFUNESTISAB NUMBER;
   V_QTFUNESTIDOM NUMBER;
   V_QTFUNESTIFER NUMBER;
   V_QTDOAESTISEG NUMBER;
   V_QTDOAESTITER NUMBER;
   V_QTDOAESTIQUA NUMBER;
   V_QTDOAESTIQUI NUMBER;
   V_QTDOAESTISEX NUMBER;
   V_QTDOAESTISAB NUMBER;
   V_QTDOAESTIDOM NUMBER;
   V_QTDOAESTIFER NUMBER;
   V_QTESTITURNO1 NUMBER;
   V_QTESTITURNO2 NUMBER;
   V_QTESTITURNO3 NUMBER;
   V_QTESTITURNO4 NUMBER;

   V_QTCOMESTICAR NUMBER;
   V_QTCLIESTICAR NUMBER;
   V_QTFUNESTICAR NUMBER;
   V_QTDOAESTICAR NUMBER;

   V_DTFERIFILI DATE; /* DATA FERIADO */

   V_INCTURNO     INTEGER;

   V_CDCENTRAL VARCHAR2(04);

   V_IDUTCARDPADR VARCHAR2(01);
   V_IDCARDIAUTIL VARCHAR2(01);

BEGIN
   SELECT MAX(IDUTCARDPADR), MAX(IDUTRPADCA)
      INTO V_IDUTCARDPADR, V_IDUTRPADCA
   FROM PARAMGERAL;
   IF (V_IDUTCARDPADR = 'S') THEN

      SELECT MAX(CDFILCENTPME)
        INTO V_CDCENTRAL
      FROM FILIAL
      WHERE CDFILIAL = P_CDFILIAL;

      IF (V_CDCENTRAL IS NOT NULL) THEN
         RETURN;
      END IF;
   END IF;

   IF (V_IDUTCARDPADR = 'D') THEN
      SELECT MAX(CDGRUPOPER)
        INTO V_CDGRUPOPER
      FROM AUTGRUPOP
      WHERE IDAUTGRUPOP = 'LRCD';

      IF V_CDGRUPOPER IS NOT NULL THEN
         SELECT MAX(CDOPERADOR)
           INTO V_CDOPERADOR
         FROM OPERGRUPOP
         WHERE CDGRUPOPER = V_CDGRUPOPER
           AND CDOPERADOR = P_CDOPERADOR;

         IF V_CDOPERADOR IS NULL THEN
            RETURN;
         END IF;
      END IF;

      SELECT NVL(MAX(IDCARDDESCENTR), 'N')
        INTO V_IDCARDDESCENTR
      FROM SERVICO
      WHERE CDFILIAL = P_CDFILIAL
        AND CDSERVFILI = P_CDSERVFILI
        AND IDTIPOSERV = 'N';

      IF V_IDCARDDESCENTR <> 'N' THEN
         SELECT MAX(DTLIBECARDMATR)
           INTO V_DTLIBECARDMATR
         FROM CTRLAPROVCARD
         WHERE CDFILIAL = P_CDFILIAL
           AND CDSERVFILI = P_CDSERVFILI
           AND DTMESCARDAPROV = P_DTMESCARD;
         IF V_DTLIBECARDMATR IS NOT NULL THEN
            RETURN;
         END IF;
      END IF;
   END IF;

   SELECT MAX(CDCARDCICLO)
      INTO V_CDCARD
   FROM CARDCICLO
   WHERE CDCARDCICLO = SUBSTR(RETORNA_NRCICLO(P_CDFILIAL, P_CDSERVFILI, P_DTMESCARD), 1, 5)
     AND IDATIVCICLO = 'S';

   IF V_CDCARD IS NULL THEN
      RETURN;
   END IF;

   SELECT COUNT(1)
     INTO V_COUNT
   FROM COMPCARDCICLO CP, CNFCARDCICLO CF
   WHERE CP.CDCARDCICLO = V_CDCARD
     AND CP.CDPADCICLO = P_CDPADCICLO
     AND CF.CDCARDCICLO = CP.CDCARDCICLO
     AND CF.CDPADCICLO = CP.CDPADCICLO
     AND CF.NRSEQCNFCICLO = CP.NRSEQCARDCICLO;

   IF NOT (V_COUNT > 0) THEN
      RETURN;
   END IF;

   IF P_IDEXCLUIRCARD = 'S' THEN
      IF (LAST_DAY(P_DTMESCARD) > LAST_DAY(SYSDATE)) THEN  --Considera para o teste apenas o mes e o ano
         DELETE FROM COMPCARD
         WHERE CDFILIAL = P_CDFILIAL
           AND NRCARDAPIO IN (SELECT NRCARDAPIO
                              FROM CARDADIA
                              WHERE CDFILIAL = P_CDFILIAL
                                AND CDSERVFILI = P_CDSERVFILI
                                AND DTMESCARD = P_DTMESCARD);

         DELETE FROM CARDADIA
         WHERE CDFILIAL = P_CDFILIAL
         AND CDSERVFILI = P_CDSERVFILI
         AND DTMESCARD = P_DTMESCARD;

         DELETE FROM CARDAMES
         WHERE CDFILIAL = P_CDFILIAL
           AND CDSERVFILI = P_CDSERVFILI
           AND DTMESCARDAPIO = P_DTMESCARD;
      END IF;
   END IF;

   SELECT MAX(DTMESCARDAPIO)
     INTO V_DTMESCARDAPIO
   FROM CARDAMES
   WHERE CDFILIAL = P_CDFILIAL
     AND CDSERVFILI = P_CDSERVFILI
     AND DTMESCARDAPIO = P_DTMESCARD;

   IF V_DTMESCARDAPIO IS NULL THEN
      DELETE FROM CNFCAMES
      WHERE CDFILIAL     = P_CDFILIAL AND
            CDSERVFILI   = P_CDSERVFILI AND
            DTREFECNFMES = P_DTMESCARD;

      INSERT INTO CNFCAMES
         (CDFILIAL, CDSERVFILI, NRSEQCNFMES, DTREFECNFMES,
          CDTIPOPRAT, IDOPCCNFMES, NRORDCNFMES, DSCOMPLTPMES,
          IDIMPCNFMES)
      SELECT P_CDFILIAL, P_CDSERVFILI, NRSEQCNFCICLO, P_DTMESCARD,
             CDTIPOPRAT, IDOPCARDCICLO, NRORDCNFCICLO, DSCOMPTPCICLO,
             'S'
      FROM CNFCARDCICLO
      WHERE CDCARDCICLO = SUBSTR(RETORNA_NRCICLO(P_CDFILIAL, P_CDSERVFILI, P_DTMESCARD), 1, 5)
        AND CDPADCICLO = P_CDPADCICLO;

      INSERT INTO CARDAMES (CDFILIAL, CDSERVFILI, DTMESCARDAPIO, IDCARDCICLO, CDCARDCICLO)
      VALUES (P_CDFILIAL, P_CDSERVFILI, P_DTMESCARD, 'S', V_CDCARD);

      V_NRSEQLOG := 0;

      FOR C_DATA IN(
         SELECT DTDATA
         FROM DATA
         WHERE DTMES = P_DTMESCARD
         ORDER BY DTDATA) LOOP

         SELECT MAX(DTFERIFILI)
            INTO V_DTFERIFILI
         FROM FERIFILI
         WHERE (CDFILIAL   = P_CDFILIAL) AND
               (DTFERIFILI = C_DATA.DTDATA);

         SELECT MAX(IDCARDIAUTIL)
           INTO V_IDCARDIAUTIL
         FROM PARAMPLANEJA
         WHERE (CDFILIAL = P_CDFILIAL);

         IF NOT ((V_DTFERIFILI IS NOT NULL) AND (V_IDCARDIAUTIL = 'S')) THEN

            ----------------------SOLICITAO 124881 ------------------------

            /*RETORNA NRO DO CICLO REFERENTE A DATA DO CARDAPIO*/
            SELECT SUBSTR(CI.NRCICLO,1,5), SUBSTR(CI.NRCICLO, 6, 3) AS NRCICLO
              INTO V_CDCARDCICLO ,V_NRCICLO
              FROM (SELECT RETORNA_NRCICLO(P_CDFILIAL, P_CDSERVFILI, C_DATA.DTDATA) AS NRCICLO FROM DUAL) CI;

            /*RETORNA A ULTIMA DATA EM QUE O CICLO RODOU EM ALGUM MES ANTERIOR*/
           /* SELECT MAX(DTDATA)
              INTO V_MAXDATA
              FROM DATA DT
              WHERE (SUBSTR((SELECT RETORNA_NRCICLO(P_CDFILIAL, P_CDSERVFILI, DT.DTDATA) AS NRCICLO FROM DUAL), 6, 3) = V_NRCICLO)
                AND (SUBSTR((SELECT RETORNA_NRCICLO(P_CDFILIAL, P_CDSERVFILI, DT.DTDATA) AS NRCICLO FROM DUAL), 1, 5) = V_CDCARDCICLO)
                AND (DT.DTDATA < (SELECT MAX(DTDATA)
                                    FROM DATA D
                                    WHERE (SUBSTR((SELECT RETORNA_NRCICLO(P_CDFILIAL, P_CDSERVFILI, D.DTDATA) AS NRCICLO FROM DUAL), 6, 3) = '1')
                                      AND (SUBSTR((SELECT RETORNA_NRCICLO(P_CDFILIAL, P_CDSERVFILI, D.DTDATA) AS NRCICLO FROM DUAL), 1, 5) = V_CDCARDCICLO)
                                      AND (D.DTDATA < P_DTMESCARD)));
            */

            SELECT NVL(SUM(QTCOMESTISEG), 0), NVL(SUM(QTCOMESTITER), 0),
                   NVL(SUM(QTCOMESTIQUA), 0), NVL(SUM(QTCOMESTIQUI), 0), NVL(SUM(QTCOMESTISEX), 0),
                   NVL(SUM(QTCOMESTISAB), 0), NVL(SUM(QTCOMESTIDOM), 0), NVL(SUM(QTCOMESTIFER), 0),
                   NVL(SUM(QTCLIESTISEG), 0), NVL(SUM(QTCLIESTITER), 0), NVL(SUM(QTCLIESTIQUA), 0),
                   NVL(SUM(QTCLIESTIQUI), 0), NVL(SUM(QTCLIESTISEX), 0), NVL(SUM(QTCLIESTISAB), 0),
                   NVL(SUM(QTCLIESTIDOM), 0), NVL(SUM(QTCLIESTIFER), 0), NVL(SUM(QTFUNESTISEG), 0),
                   NVL(SUM(QTFUNESTITER), 0), NVL(SUM(QTFUNESTIQUA), 0), NVL(SUM(QTFUNESTIQUI), 0),
                   NVL(SUM(QTFUNESTISEX), 0), NVL(SUM(QTFUNESTISAB), 0), NVL(SUM(QTFUNESTIDOM), 0),
                   NVL(SUM(QTFUNESTIFER), 0), NVL(SUM(QTDOAESTISEG), 0), NVL(SUM(QTDOAESTITER), 0),
                   NVL(SUM(QTDOAESTIQUA), 0), NVL(SUM(QTDOAESTIQUI), 0), NVL(SUM(QTDOAESTISEX), 0),
                   NVL(SUM(QTDOAESTISAB), 0), NVL(SUM(QTDOAESTIDOM), 0), NVL(SUM(QTDOAESTIFER), 0)
              INTO V_QTCOMESTISEG, V_QTCOMESTITER,
                   V_QTCOMESTIQUA, V_QTCOMESTIQUI, V_QTCOMESTISEX,
                   V_QTCOMESTISAB, V_QTCOMESTIDOM, V_QTCOMESTIFER,
                   V_QTCLIESTISEG, V_QTCLIESTITER, V_QTCLIESTIQUA,
                   V_QTCLIESTIQUI, V_QTCLIESTISEX, V_QTCLIESTISAB,
                   V_QTCLIESTIDOM, V_QTCLIESTIFER, V_QTFUNESTISEG,
                   V_QTFUNESTITER, V_QTFUNESTIQUA, V_QTFUNESTIQUI,
                   V_QTFUNESTISEX, V_QTFUNESTISAB, V_QTFUNESTIDOM,
                   V_QTFUNESTIFER, V_QTDOAESTISEG, V_QTDOAESTITER,
                   V_QTDOAESTIQUA, V_QTDOAESTIQUI, V_QTDOAESTISEX,
                   V_QTDOAESTISAB, V_QTDOAESTIDOM, V_QTDOAESTIFER
            FROM SERVICO
            WHERE CDFILIAL = P_CDFILIAL
              AND CDSERVFILI = P_CDSERVFILI
            GROUP BY CDFILIAL, CDSERVFILI;

            IF (V_DTFERIFILI IS NULL) THEN
               SELECT MAX(DTFERICARD)
                 INTO V_DTFERIFILI
               FROM FERICARD
               WHERE CDFILIAL = P_CDFILIAL
                 AND DTFERICARD = C_DATA.DTDATA;
            END IF;

            IF (V_DTFERIFILI IS NOT NULL) THEN
                /* Grava comensais para Feriado */
               V_QTCOMESTICAR := V_QTCOMESTIFER;
               V_QTCLIESTICAR := V_QTCLIESTIFER;
               V_QTFUNESTICAR := V_QTFUNESTIFER;
               V_QTDOAESTICAR := V_QTDOAESTIFER;
            ELSE
               /* Grava comensais para os dias da semana (no-feriados) */
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '1' THEN
                  V_QTCOMESTICAR := V_QTCOMESTIDOM;
                  V_QTCLIESTICAR := V_QTCLIESTIDOM;
                  V_QTFUNESTICAR := V_QTFUNESTIDOM;
                  V_QTDOAESTICAR := V_QTDOAESTIDOM;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '2' THEN
                  V_QTCOMESTICAR := V_QTCOMESTISEG;
                  V_QTCLIESTICAR := V_QTCLIESTISEG;
                  V_QTFUNESTICAR := V_QTFUNESTISEG;
                  V_QTDOAESTICAR := V_QTDOAESTISEG;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '3' THEN
                  V_QTCOMESTICAR := V_QTCOMESTITER;
                  V_QTCLIESTICAR := V_QTCLIESTITER;
                  V_QTFUNESTICAR := V_QTFUNESTITER;
                  V_QTDOAESTICAR := V_QTDOAESTITER;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '4' THEN
                  V_QTCOMESTICAR := V_QTCOMESTIQUA;
                  V_QTCLIESTICAR := V_QTCLIESTIQUA;
                  V_QTFUNESTICAR := V_QTFUNESTIQUA;
                  V_QTDOAESTICAR := V_QTDOAESTIQUA;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '5' THEN
                  V_QTCOMESTICAR := V_QTCOMESTIQUI;
                  V_QTCLIESTICAR := V_QTCLIESTIQUI;
                  V_QTFUNESTICAR := V_QTFUNESTIQUI;
                  V_QTDOAESTICAR := V_QTDOAESTIQUI;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '6' THEN
                  V_QTCOMESTICAR := V_QTCOMESTISEX;
                  V_QTCLIESTICAR := V_QTCLIESTISEX;
                  V_QTFUNESTICAR := V_QTFUNESTISEX;
                  V_QTDOAESTICAR := V_QTDOAESTISEX;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '7' THEN
                  V_QTCOMESTICAR := V_QTCOMESTISAB;
                  V_QTCLIESTICAR := V_QTCLIESTISAB;
                  V_QTFUNESTICAR := V_QTFUNESTISAB;
                  V_QTDOAESTICAR := V_QTDOAESTISAB;
               END IF;
            END IF;

            V_INCTURNO := 1;
            FOR C_TURNO IN(
               SELECT QTCOMESTTDOM, QTCOMESTTSEG, QTCOMESTTTER,
                      QTCOMESTTQUA, QTCOMESTTQUI, QTCOMESTTSEX,
                      QTCOMESTTSAB, QTCOMESTTFER
               FROM TURNOSERV
               WHERE CDFILIAL = P_CDFILIAL
                 AND CDSERVFILI = P_CDSERVFILI
               ORDER BY CDTURNO) LOOP

               IF TO_CHAR(C_DATA.DTDATA, 'D') = '1' THEN
                  IF V_INCTURNO = 1 THEN
                     V_QTESTITURNO1 := C_TURNO.QTCOMESTTDOM;
                  END IF;
                  IF V_INCTURNO = 2 THEN
                     V_QTESTITURNO2 := C_TURNO.QTCOMESTTDOM;
                  END IF;
                  IF V_INCTURNO = 3 THEN
                     V_QTESTITURNO3 := C_TURNO.QTCOMESTTDOM;
                  END IF;
                  IF V_INCTURNO = 4 THEN
                     V_QTESTITURNO4 := C_TURNO.QTCOMESTTDOM;
                  END IF;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '2' THEN
                  IF V_INCTURNO = 1 THEN
                     V_QTESTITURNO1 := C_TURNO.QTCOMESTTSEG;
                  END IF;
                  IF V_INCTURNO = 2 THEN
                     V_QTESTITURNO2 := C_TURNO.QTCOMESTTSEG;
                  END IF;
                  IF V_INCTURNO = 3 THEN
                     V_QTESTITURNO3 := C_TURNO.QTCOMESTTSEG;
                  END IF;
                  IF V_INCTURNO = 4 THEN
                     V_QTESTITURNO4 := C_TURNO.QTCOMESTTSEG;
                  END IF;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '3' THEN
                  IF V_INCTURNO = 1 THEN
                     V_QTESTITURNO1 := C_TURNO.QTCOMESTTTER;
                  END IF;
                  IF V_INCTURNO = 2 THEN
                     V_QTESTITURNO2 := C_TURNO.QTCOMESTTTER;
                  END IF;
                  IF V_INCTURNO = 3 THEN
                     V_QTESTITURNO3 := C_TURNO.QTCOMESTTTER;
                  END IF;
                  IF V_INCTURNO = 4 THEN
                     V_QTESTITURNO4 := C_TURNO.QTCOMESTTTER;
                  END IF;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '4' THEN
                  IF V_INCTURNO = 1 THEN
                     V_QTESTITURNO1 := C_TURNO.QTCOMESTTQUA;
                  END IF;
                  IF V_INCTURNO = 2 THEN
                     V_QTESTITURNO2 := C_TURNO.QTCOMESTTQUA;
                  END IF;
                  IF V_INCTURNO = 3 THEN
                     V_QTESTITURNO3 := C_TURNO.QTCOMESTTQUA;
                  END IF;
                  IF V_INCTURNO = 4 THEN
                     V_QTESTITURNO4 := C_TURNO.QTCOMESTTQUA;
                  END IF;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '5' THEN
                  IF V_INCTURNO = 1 THEN
                     V_QTESTITURNO1 := C_TURNO.QTCOMESTTQUI;
                  END IF;
                  IF V_INCTURNO = 2 THEN
                     V_QTESTITURNO2 := C_TURNO.QTCOMESTTQUI;
                  END IF;
                  IF V_INCTURNO = 3 THEN
                     V_QTESTITURNO3 := C_TURNO.QTCOMESTTQUI;
                  END IF;
                  IF V_INCTURNO = 4 THEN
                     V_QTESTITURNO4 := C_TURNO.QTCOMESTTQUI;
                  END IF;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '6' THEN
                  IF V_INCTURNO = 1 THEN
                     V_QTESTITURNO1 := C_TURNO.QTCOMESTTSEX;
                  END IF;
                  IF V_INCTURNO = 2 THEN
                     V_QTESTITURNO2 := C_TURNO.QTCOMESTTSEX;
                  END IF;
                  IF V_INCTURNO = 3 THEN
                     V_QTESTITURNO3 := C_TURNO.QTCOMESTTSEX;
                  END IF;
                  IF V_INCTURNO = 4 THEN
                     V_QTESTITURNO4 := C_TURNO.QTCOMESTTSEX;
                  END IF;
               END IF;
               IF TO_CHAR(C_DATA.DTDATA, 'D') = '7' THEN
                  IF V_INCTURNO = 1 THEN
                     V_QTESTITURNO1 := C_TURNO.QTCOMESTTSAB;
                  END IF;
                  IF V_INCTURNO = 2 THEN
                     V_QTESTITURNO2 := C_TURNO.QTCOMESTTSAB;
                  END IF;
                  IF V_INCTURNO = 3 THEN
                     V_QTESTITURNO3 := C_TURNO.QTCOMESTTSAB;
                  END IF;
                  IF V_INCTURNO = 4 THEN
                     V_QTESTITURNO4 := C_TURNO.QTCOMESTTSAB;
                  END IF;
               END IF;

               IF (V_DTFERIFILI IS NOT NULL) THEN
                  IF V_INCTURNO = 1 THEN
                     V_QTESTITURNO1 := C_TURNO.QTCOMESTTFER;
                  END IF;
                  IF V_INCTURNO = 2 THEN
                     V_QTESTITURNO2 := C_TURNO.QTCOMESTTFER;
                  END IF;
                  IF V_INCTURNO = 3 THEN
                     V_QTESTITURNO3 := C_TURNO.QTCOMESTTFER;
                  END IF;
                  IF V_INCTURNO = 4 THEN
                     V_QTESTITURNO4 := C_TURNO.QTCOMESTTFER;
                  END IF;
               END IF;

               V_INCTURNO := V_INCTURNO + 1;

            END LOOP;

            IF (V_QTCOMESTICAR > 0) THEN
               V_NRCARDAPIO := NULL;
               FOR C_COMPCARD IN (
                  SELECT CP.NRSEQCARDCICLO, CP.CDFILAUXPRAT, CP.CDPRATO,
                         CP.CDTIPOPRAT, CF.NRORDCNFCICLO, CP.VRPECONSCARDCICLO
                  FROM COMPCARDCICLO CP, CNFCARDCICLO CF,
                      (SELECT RETORNA_NRCICLO(P_CDFILIAL, P_CDSERVFILI, C_DATA.DTDATA) AS NRCICLO FROM DUAL) CI
                  WHERE CP.CDCARDCICLO = SUBSTR(CI.NRCICLO, 1, 5)
                    AND CP.NRCARDCICLO = SUBSTR(CI.NRCICLO, 6, 3)
                    AND CP.CDPADCICLO = P_CDPADCICLO
                    AND CF.CDCARDCICLO = CP.CDCARDCICLO
                    AND CF.CDPADCICLO = CP.CDPADCICLO
                    AND CF.NRSEQCNFCICLO = CP.NRSEQCARDCICLO) LOOP

                  /* IDUTRPADCA = 'N' --> NO PERMITE RECEITA PADRO NO CARDPIO */
                  V_CONTPRODRECE := 0;
                  IF V_IDUTRPADCA = 'N' THEN
                     SELECT SUM(NUM)
                     INTO V_CONTPRODRECE
                     FROM (SELECT COUNT(1) NUM
                           FROM RECEFILI
                           WHERE CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                             AND CDPRATO = C_COMPCARD.CDPRATO
                             AND CDFILIAL = P_CDFILIAL
                           UNION ALL
                           SELECT COUNT(1) NUM
                           FROM RECESERV
                           WHERE CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                             AND CDPRATO = C_COMPCARD.CDPRATO
                             AND CDFILIAL = P_CDFILIAL
                             AND CDSERVFILI = P_CDSERVFILI);
                  ELSE
                     SELECT SUM(NUM)
                     INTO V_CONTPRODRECE
                     FROM (SELECT COUNT(1) NUM
                           FROM RECEPADR
                           WHERE CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                             AND CDPRATO = C_COMPCARD.CDPRATO
                           UNION ALL
                           SELECT COUNT(1) NUM
                           FROM RECEFILI
                           WHERE CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                             AND CDPRATO = C_COMPCARD.CDPRATO
                             AND CDFILIAL = P_CDFILIAL
                           UNION ALL
                           SELECT COUNT(1) NUM
                           FROM RECESERV
                           WHERE CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                             AND CDPRATO = C_COMPCARD.CDPRATO
                             AND CDFILIAL = P_CDFILIAL
                             AND CDSERVFILI = P_CDSERVFILI);
                  END IF;

                  /* VERIFICAR SE H PRODUTO INATIVO NO PRATO */
                  /* verificar a receita utilizada pelo prato destino */
                  V_TIPORECE := 'N';
                  SELECT NVL(MAX(TIPO), 'N')
                    INTO V_TIPORECE
                  FROM (SELECT 'S' AS TIPO
                        FROM RECESERV
                        WHERE CDFILIAL = P_CDFILIAL
                          AND CDSERVFILI = P_CDSERVFILI
                          AND CDPRATO = C_COMPCARD.CDPRATO
                          AND CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                        UNION ALL
                        SELECT 'F' AS TIPO
                        FROM RECEFILI F
                        WHERE CDFILIAL = P_CDFILIAL
                          AND CDPRATO = C_COMPCARD.CDPRATO
                          AND CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                          AND NOT EXISTS (SELECT CDPRATO
                                          FROM RECESERV
                                          WHERE CDFILIAL = F.CDFILIAL
                                            AND CDSERVFILI = P_CDSERVFILI
                                            AND CDPRATO = F.CDPRATO
                                            AND CDFILAUXPRAT = F.CDFILAUXPRAT)
                        UNION ALL
                        SELECT 'P' AS TIPO
                        FROM RECEPADR P
                        WHERE CDPRATO = C_COMPCARD.CDPRATO
                          AND CDFILAUXPRAT = P_CDFILIAL
                          AND NOT EXISTS(SELECT CDPRATO
                                         FROM RECEFILI
                                         WHERE CDFILIAL = P_CDFILIAL
                                           AND CDPRATO = P.CDPRATO
                                           AND CDFILAUXPRAT = P.CDFILAUXPRAT)
                          AND NOT EXISTS (SELECT CDPRATO
                                          FROM RECESERV
                                          WHERE CDFILIAL = P_CDFILIAL
                                            AND CDSERVFILI = P_CDSERVFILI
                                            AND CDPRATO = P.CDPRATO
                                            AND CDFILAUXPRAT = P.CDFILAUXPRAT)) A;
                  /************************/
                  /*Parametro para selecionar apenas produto de nvel completo*/
                  SELECT MAX(CDNVPRODUTO)
                    INTO V_CDNVPRODUTO
                  FROM PRODUTO;

                  V_PRODINATIVO := FALSE;

                  IF (V_TIPORECE = 'S') THEN  /*RECEITA POR SERVIO COM PRODUTO INATIVO*/
                     FOR C_RECESERV IN (
                        SELECT P.CDPRODUTO, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                        FROM PRODUTO P, PRODFILI PF, RECESERV RS
                        WHERE PF.CDPRODUTO(+) = P.CDPRODUTO
                          AND PF.CDFILIAL (+) = P_CDFILIAL
                          AND P.CDNVPRODUTO = V_CDNVPRODUTO
                          AND RS.CDFILIAL = P_CDFILIAL
                          AND RS.CDSERVFILI = P_CDSERVFILI
                          AND RS.CDPRATO = C_COMPCARD.CDPRATO
                          AND RS.CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                          AND P.CDPRODUTO = RS.CDPRODUTO) LOOP
                        IF (C_RECESERV.IDPRODATIV = 'I') OR (C_RECESERV.IDPRODATIVPR = 'N') THEN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                           V_PRODINATIVO := TRUE;
                           V_NRSEQLOG := V_NRSEQLOG+1;
                           INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, CDPADCICLO)
                           VALUES(P_NRLOGCARDCICLO, V_NRSEQLOG, C_DATA.DTDATA, '0', P_CDFILIAL, P_CDSERVFILI, C_COMPCARD.CDPRATO, C_COMPCARD.CDFILAUXPRAT, C_RECESERV.CDPRODUTO, P_CDPADCICLO);
                        END IF;
                     END LOOP;
                  ELSE
                     IF (V_TIPORECE = 'F') THEN  /*RECEITA LOCAL COM PRODUTO INATIVO*/
                        FOR C_RECEFILI IN (
                           SELECT P.CDPRODUTO, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                           FROM PRODUTO P, PRODFILI PF, RECEFILI RF
                           WHERE PF.CDPRODUTO(+) = P.CDPRODUTO
                             AND PF.CDFILIAL (+) = P_CDFILIAL
                             AND P.CDNVPRODUTO = V_CDNVPRODUTO
                             AND RF.CDFILIAL = P_CDFILIAL
                             AND RF.CDPRATO = C_COMPCARD.CDPRATO
                             AND RF.CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                             AND P.CDPRODUTO = RF.CDPRODUTO) LOOP
                           IF (C_RECEFILI.IDPRODATIV = 'I') OR (C_RECEFILI.IDPRODATIVPR = 'N') THEN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                              V_PRODINATIVO := TRUE;
                              V_NRSEQLOG := V_NRSEQLOG+1;
                              INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, CDPADCICLO)
                              VALUES(P_NRLOGCARDCICLO, V_NRSEQLOG, C_DATA.DTDATA, '0', P_CDFILIAL, P_CDSERVFILI, C_COMPCARD.CDPRATO, C_COMPCARD.CDFILAUXPRAT, C_RECEFILI.CDPRODUTO, P_CDPADCICLO);
                           END IF;
                        END LOOP;
                     ELSE
                        IF (V_TIPORECE ='P') THEN   /*RECEITA PADRO COM PRODUTO INATIVO*/
                           FOR C_RECEPADR IN (
                              SELECT P.CDPRODUTO, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                              FROM PRODUTO P, PRODFILI PF, RECEPADR RP
                              WHERE P.CDNVPRODUTO = V_CDNVPRODUTO
                                AND P_CDFILIAL = PF.CDFILIAL(+)
                                AND P.CDPRODUTO = PF.CDPRODUTO(+)
                                AND RP.CDPRATO = C_COMPCARD.CDPRATO
                                AND RP.CDFILAUXPRAT = C_COMPCARD.CDFILAUXPRAT
                                AND RP.CDPRODUTO = P.CDPRODUTO) LOOP
                              IF (C_RECEPADR.IDPRODATIV = 'I') OR (C_RECEPADR.IDPRODATIVPR = 'N') THEN /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                 V_PRODINATIVO := TRUE;
                                 V_NRSEQLOG := V_NRSEQLOG+1;
                                 INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, CDPADCICLO)
                                 VALUES(P_NRLOGCARDCICLO, V_NRSEQLOG, C_DATA.DTDATA, '0', P_CDFILIAL, P_CDSERVFILI, C_COMPCARD.CDPRATO, C_COMPCARD.CDFILAUXPRAT, C_RECEPADR.CDPRODUTO, P_CDPADCICLO);
                              END IF;
                           END LOOP;
                        END IF; /*RECEITA PADRO COM PRODUTO INATIVO*/
                     END IF;  /*RECEITA LOCAL COM PRODUTO INATIVO */
                  END IF; /*RECEITA POR SERVIO COM PRODUTO INATIVO */
                          /***********************/
                          /* FIM - VERIFICAR SE H PRODUTO INATIVO NO PRATO */
                  IF V_CONTPRODRECE = 0 THEN
                     V_NRSEQLOG := V_NRSEQLOG+1;
                     INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPADCICLO)
                     VALUES(P_NRLOGCARDCICLO, V_NRSEQLOG, C_DATA.DTDATA, '1', P_CDFILIAL, P_CDSERVFILI, C_COMPCARD.CDPRATO, C_COMPCARD.CDFILAUXPRAT, P_CDPADCICLO);
                  END IF;

                  IF (V_PRODINATIVO = FALSE) AND (V_CONTPRODRECE > 0) THEN
                     SELECT MAX(NRCARDAPIO)
                       INTO V_NRCARDAPIO
                       FROM CARDADIA
                      WHERE CDFILIAL = P_CDFILIAL
                        AND CDSERVFILI = P_CDSERVFILI
                        AND DTCARDAPIO = C_DATA.DTDATA
                        AND CDDIETPAD IS NULL;

                     IF V_NRCARDAPIO IS NULL THEN
                        NOVO_CODIGO_SC('CARDAPIO'||P_CDFILIAL, V_NRCARDAPIO, 1);
                        V_NRCARDAPIO := SUBSTR(V_NRCARDAPIO, 11, 10);


                        INSERT INTO CARDADIA(CDFILIAL,     NRCARDAPIO,   CDSERVFILI,
                                             CDOPERADOR,   DTCARDAPIO,   DTMESCARD,
                                             QTCOMESTICAR, QTESTITURNO1, QTESTITURNO2,
                                             QTESTITURNO3, QTESTITURNO4, QTCLIESTICAR,
                                             QTFUNESTICAR, QTDOAESTICAR)
                        VALUES(P_CDFILIAL, SUBSTR(V_NRCARDAPIO, 1, 10), P_CDSERVFILI,
                               P_CDOPERADOR, C_DATA.DTDATA, P_DTMESCARD,
                               V_QTCOMESTICAR, V_QTESTITURNO1, V_QTESTITURNO2,
                               V_QTESTITURNO3, V_QTESTITURNO4, V_QTCLIESTICAR,
                               V_QTFUNESTICAR, V_QTDOAESTICAR);
                     END IF;

                     /*VERIFICA O PERCENTUAL DE APROVEITAMENTO DO PRATO NO CICLO ANTERIOR, SE NO EXISTIR VAI INSERIR 100*/
                     /*SELECT MAX(CM.VRPECONSCARD), MAX(CM.CDPRATO)
                       INTO V_VRPECONSCARD ,V_CDPRATO
                       FROM COMPCARD CM, CARDADIA CD
                      WHERE CM.CDFILIAL = P_CDFILIAL
                        AND CM.NRSEQPRATCAR = C_COMPCARD.NRSEQCARDCICLO
                        AND CM.CDTIPOPRAT = C_COMPCARD.CDTIPOPRAT
                        AND CM.CDFILIAL = CD.CDFILIAL
                        AND CD.CDSERVFILI  = P_CDSERVFILI
                        AND CM.NRCARDAPIO = CD.NRCARDAPIO
                        AND CD.DTCARDAPIO = V_MAXDATA ;


                     IF (V_VRPECONSCARD) IS NULL THEN
                        V_VRPECONSCARD := 100;
                     ELSE
                        IF V_CDPRATO <> C_COMPCARD.CDPRATO THEN -- SE PRATOS FOREM DIFERENTES INSERE UMA RESTRICAO NO LOG
                           V_NRSEQLOG := V_NRSEQLOG+1;
                           INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPADCICLO)
                           VALUES(P_NRLOGCARDCICLO, V_NRSEQLOG, C_DATA.DTDATA, '3', P_CDFILIAL, P_CDSERVFILI, C_COMPCARD.CDPRATO, C_COMPCARD.CDFILAUXPRAT, P_CDPADCICLO);
                        END IF;
                     END IF;*/
                     INSERT INTO COMPCARD(CDFILIAL,     NRCARDAPIO, NRSEQPRATCAR,
                                          CDFILAUXPRAT, CDPRATO,    VRPECONSCARD,
                                          CDTIPOPRAT, NRORDPRATCAR)
                     VALUES(P_CDFILIAL, V_NRCARDAPIO, C_COMPCARD.NRSEQCARDCICLO,
                            C_COMPCARD.CDFILAUXPRAT, C_COMPCARD.CDPRATO, C_COMPCARD.VRPECONSCARDCICLO /*V_VRPECONSCARD*/,
                            C_COMPCARD.CDTIPOPRAT, C_COMPCARD.NRORDCNFCICLO);
                  END IF;
                                            ----------------------SOLICITAO 124881 ------------------------
               END LOOP;
            ELSE
               V_NRSEQLOG := V_NRSEQLOG+1;
               INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPADCICLO)
               VALUES(P_NRLOGCARDCICLO, V_NRSEQLOG, C_DATA.DTDATA, '2', P_CDFILIAL, P_CDSERVFILI, NULL, NULL, P_CDPADCICLO);
            END IF;
         END IF;
      END LOOP;
   END IF;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CRIACARD_CICLO','5.50.000'); END;
/

